<?php

declare(strict_types = 1);

namespace Internetgalerie\IgFormlog\Mvc\View;

/*
 * This file is part of the Internetgalerie TYPO3 IgFormlog project.
 */

use TYPO3Fluid\Fluid\View\ViewInterface;
use TYPO3\CMS\Extbase\Mvc\View\ViewResolverInterface;
use TYPO3\CMS\Fluid\View\TemplateView;

final class FormatViewResolver implements ViewResolverInterface
{
    /**
     * @var string[]
     */
    private array $formatMap = [];


    public function map(string $format, string $viewClassName): void
    {
        $this->formatMap[$format] = $viewClassName;
    }

    public function resolve(string $controllerObjectName, string $actionName, string $format): ViewInterface
    {
        $viewClassName = $this->formatMap[$format] ?? TemplateView::class;

        return GeneralUtility::makeInstance($viewClassName);
    }
}
